;
;
;

	LIST P=PIC12F675, R=DEC
	include<p12f675.inc>

BARO_IN_GP0	EQU	000H		; Preasure (A/D) in port
BARO_VREF_GP1	EQU	001H		; VREF for A/D in port
SHT11_DAT	EQU	002H		; data line for SHT11 sensor (GP2)
IN232_GP3	EQU	003H		; RS232 INPUT
SHT11_SCK	EQU	004H		; clock line for SHT11 sensor (GP4)
OUT232_GP5	EQU	005H		; RS232 OUTPUT

poc_mer		EQU	020H		;
horniSOUCET	EQU	021H		;
SOUCET		EQU	022H		;
temp0		EQU	023H		;
temp1		EQU	024H		;
temp2		EQU	025H		;
countH		EQU	026H		;
countL		EQU	027H		;
stridaH		EQU	028H		;
stridaL		EQU	029H		;
DELAY_1		EQU	02AH		;
DELAY_2		EQU	02BH		;
SHT11Byte	EQU	02CH		;
		; 02D Volne
TeplFs		EQU	02EH		;
TeplFd		EQU	02FH		;
TeplFj		EQU	030H		;

Tlak_id		EQU	031H		;

TlakT		EQU	032H		;
TlakS		EQU	033H		;
TlakD		EQU	034H		;
TlakJ		EQU	035H		;
TlakDes		EQU	036H		;

Vlhk_id		EQU	037H		;

VlhkD		EQU	038H		;
VlhkJ		EQU	039H		;

WX_end_CR	EQU	03AH		;

pod_nulou	EQU	03BH		; Indikace teploty pod nulou
TeplH		EQU	03CH		; ASCII 10ky teploty
TeplL		EQU	03DH		; ASCII jednotky teploty
desetiny	EQU	03EH		; ASCII desetiny stupnu
Cels_id		EQU	03FH		;

		; 040-055 pouziva aritmetika
MSDelay		EQU	056H		;
MATH_tempE	EQU	057H		;
MATH_temp0	EQU	058H		;
MATH_temp1	EQU	059H		;
MATH_temp2	EQU	05AH		;
tempE		EQU	05BH		;
delay_time	EQU	05CH		;
serialDelayCount EQU	05DH		; Registr casovani RS232
serialCount	EQU	05EH		; Pocet bitu pro RS232
serialData	EQU	05FH		; Byte pro zpracovani RS232kou




		
		ORG	0000H
		
Zacatek		MOVLW	07H			; 
		MOVWF	CMCON			; odpojit komparatory
		MOVLW	a'b'			; male 'b' dat 
		MOVWF	Tlak_id			; sem jako id tlaku
		MOVLW	a'h'			; male 'h' dat 
		MOVWF	Vlhk_id			; sem jako id vlhkosti
		MOVLW	00DH			; '<CR>' dat 
		MOVWF	WX_end_CR		; sem, priznak konce WX 
		MOVLW	a'C'			; velke 'C' dat 
		MOVWF	Cels_id			; sem jako id stupnu Cels.
		CALL	InitIO			; Nastavit seriovy I/O
		CALL	serialTXlfcr		; odradkovat

Start						; Mereni 

		; Test jestli merime teplotu, nebo konfigurujeme, kdyz RS232IN=0
		BTFSS	GPIO, IN232_GP3		; merime? = LOG 1
		GOTO	Kalibrace		; Nikoli, kalibrujeme

Startup_delay					; pockat 
		DECFSZ	DELAY_1, F		; cca 130ms
		GOTO	Startup_delay		; nez se ustali
		DECFSZ	DELAY_2, F		; merene veliciny
		GOTO	Startup_delay		; a asi i procesor
				
SHT_Temperature					;
		MOVLW	03H			; Prikaz pro mereni teploty
		CALL	SHT11TXRX		; a zavolat mereni
		; Spocitat teplotu (vysledek v celociselnych desetinach C)
		; Vzorec: T = 0.1 * SOt - 400
		;      0.1d = 7B 4C CC CD float (z fprep.exe)
		;      400d = 87 48 00 00 float (z fprep.exe)
		CALL	Get_Senz_data		; data z SHT do AARG ve flo32
		;      0.1d = 7B 4C CC CD float (z fprep.exe)
		MOVLW	07BH			; Pripravit nasobeni 
		MOVWF	BEXP			; 
		MOVLW	04CH			; 
		MOVWF	BARGB0			; 
		MOVLW	0CCH			; 
		MOVWF	BARGB1			; 
		MOVLW	0CDH			; 
		MOVWF	BARGB2			; 
		CALL	FPM32			; vynasobit
		;      400d = 87 48 00 00 float (z fprep.exe)
		MOVLW	087H			; Pripravit odecteni
		MOVWF	BEXP			; 
		MOVLW	048H			; 
		MOVWF	BARGB0			; 
		CLRF	BARGB1			; 
		CLRF	BARGB2			; 
		CALL	FPS32			; odecist
		CALL	INT3224			; a prevest na int 
		MOVF	AARGB0, W		; a schovat pro 
		MOVWF	MATH_temp0		; vypocet
		MOVF	AARGB1, W		; vlhkosti
		MOVWF	MATH_temp1		; 
		MOVF	AARGB2, W		; 
		MOVWF	MATH_temp2		; 
		MOVLW	020H			; znamenko "+" (mezeru)
		MOVWF	pod_nulou		; ulozit sem
		BTFSS	AARGB0, 7		; mame zaporne stupne C?
		GOTO	SOt_kladne		; ne, jsou kladne
		CALL	Complement3		; na COMF je podprogram
		;COMF	AARGB0, F		; ano, udelat 2kovy komplement
		;COMF	AARGB1, F		; ano, udelat 2kovy komplement
		;COMF	AARGB2, F		; ano, udelat 2kovy komplement
		MOVLW	02DH			; znamenko "-"
		MOVWF	pod_nulou		; ulozit sem

SOt_kladne					; 
		CALL	Prepare_Int16ascii	; pripravit byty pro prevod
		movlw	03H	         	; prevod na 3 mistne
		movwf	digit_count     	; desitkove cislo
		movlw	desetiny		; desetiny zacinaji zde
		CALL	int16ascii		; prevest na ascii

		CALL	Get_Saved_temp		; teplotu do AARG ve flo32

		; Prevest C na F dle vzorce $F = (1.8 * $C) + 32
		; pro pocet desetin C je to $F = (0.18 * $C) + 32
		;    32d = 84 00 00 00 float (z fprep.exe)
		;  0.18d = 7C 38 51 EC float (z fprep.exe)
		MOVLW	07CH			; Pripravit nasobeni cislem
		MOVWF	BEXP			; 0.18
		MOVLW	038H			; 
		MOVWF	BARGB0			; 
		MOVLW	051H			; 
		MOVWF	BARGB1			; 
		MOVLW	0ECH			; 
		MOVWF	BARGB2			; 
		CALL	FPM32			; vynasobit
		;   32d  = 84 00 00 00 float (z fprep.exe)
		MOVLW	084H			; Pripravit pricteni cisla
		MOVWF	BEXP			; 32
		CLRF	BARGB0			; 
		CLRF	BARGB1			; 
		CLRF	BARGB2			; 
		CALL	FPA32			; secist
		CALL	INT3224			; a prevest na int 
		
		CLRF	temp0			;
		BTFSS	AARGB0, 7		; mame zaporne stupne F?
		GOTO	F_kladne		; ne, jsou kladne
		CALL	Complement3		; na COMF je podprogram
		;COMF	AARGB0, F		; ano, udelat 2kovy komplement
		;COMF	AARGB1, F		; ano, udelat 2kovy komplement
		;COMF	AARGB2, F		; ano, udelat 2kovy komplement
		BSF	temp0, 0		; priznak zapornosti

F_kladne					;
		CALL	Prepare_Int8ascii	; pripravit byty pro prevod
		movlw	03H	         	; prevod na 3 mistne
		movwf	digit_count     	; desitkove cislo
		movlw	TeplFj			; jednotky zacinaji zde
		CALL	int16ascii		; prevest na ascii
		MOVLW	02DH			; znamenko "-"
		BTFSC	temp0, 0		; jsme <0F ?
		MOVWF	TeplFs			; ano, ulozit znamenko


SHT_Humidity					;
		MOVLW	05H			; Prikaz pro mereni vlhkosti
		CALL	SHT11TXRX		; a zavolat mereni
		; Spocitat vlhkost (vysledek v celociselnych procentech)
		; Vzorec: 
		; RHtrue = 0.001 * T - 4.25 + SOrh * (0.000008 * T + 0.0385 
		; 				      - 0.0000028 * SOhr)
		;    0.001d  = 75 03 12 6F float (z fprep.exe)
		;     4.25d  = 81 08 00 00 float (z fprep.exe)
		; 0.000008d  = 6E 06 37 BD float (z fprep.exe)
		;    0.0385d = 7A 1D B2 2D float (z fprep.exe)
		; 0.0000028d = 6C 3B E7 A2 float (z fprep.exe)
		CALL	Get_Saved_temp		; teplotu do AARG ve flo32
		;    0.001d  = 75 03 12 6F float (z fprep.exe)
		MOVLW	075H			; Pripravit nasobeni 
		MOVWF	BEXP			; 
		MOVLW	003H			; 
		MOVWF	BARGB0			; 
		MOVLW	012H			; 
		MOVWF	BARGB1			; 
		MOVLW	06FH			; 
		MOVWF	BARGB2			; 
		CALL	FPM32			; vynasobit
		;     4.25d  = 81 08 00 00 float (z fprep.exe)
		MOVLW	081H			; Pripravit odecteni
		MOVWF	BEXP			; 
		MOVLW	008H			; 
		MOVWF	BARGB0			; 
		CLRF	BARGB1			; 
		CLRF	BARGB2			; 
		CALL	FPS32			; odecist
		MOVF	AEXP, W			; a schovat pro 
		MOVWF	tempE			;
		MOVF	AARGB0, W		;
		MOVWF	temp0			; pricteni  
		MOVF	AARGB1, W		; az bude 
		MOVWF	temp1			; spocitan 
		MOVF	AARGB2, W		; zbytek
		MOVWF	temp2			; vzorecku

		CALL	Get_Saved_temp		; teplotu do AARG ve flo32
		; 0.000008d  = 6E 06 37 BD float (z fprep.exe)
		MOVLW	06EH			; Pripravit nasobeni 
		MOVWF	BEXP			; 
		MOVLW	006H			; 
		MOVWF	BARGB0			; 
		MOVLW	037H			; 
		MOVWF	BARGB1			; 
		MOVLW	0BDH			; 
		MOVWF	BARGB2			; 
		CALL	FPM32			; vynasobit
		;    0.0385d = 7A 1D B2 2D float (z fprep.exe)
		MOVLW	07AH			; Pripravit pricteni
		MOVWF	BEXP			; 
		MOVLW	01DH			; 
		MOVWF	BARGB0			; 
		MOVLW	0B2H			; 
		MOVWF	BARGB1			; 
		MOVLW	02DH			; 
		MOVWF	BARGB2			; 
		CALL	FPA32			; pricist

		MOVF	AEXP, W			; schovat (T*0.00008 + 0.0385) 
		MOVWF	MATH_tempE		; v docasnych registrech
		MOVF	AARGB0, W		; (prepise tam 
		MOVWF	MATH_temp0		;  ulozenou teplotu,  
		MOVF	AARGB1, W		;  pozor na posloupnost!)
		MOVWF	MATH_temp1		; Teplota tam ulozena uz 
		MOVF	AARGB2, W		; nebude dale potreba, muzeme
		MOVWF	MATH_temp2		; si to tedy zde dovolit.

		CALL	Get_Senz_data		; data z SHT do AARG ve flo32
		; 0.0000028d = 6C 3B E7 A2 float (z fprep.exe)
		MOVLW	06CH			; Pripravit nasobeni 
		MOVWF	BEXP			; 
		MOVLW	03BH			; 
		MOVWF	BARGB0			; 
		MOVLW	0E7H			; 
		MOVWF	BARGB1			; 
		MOVLW	0A2H			; 
		MOVWF	BARGB2			; 
		CALL	FPM32			; vynasobit
		CALL	AAGR_to_BARG		; presun AARG do BARG

		MOVF	MATH_tempE, W		; obnovit 
		MOVWF	AEXP			; schovaneho 
		MOVF	MATH_temp0, W		; scitance 
		MOVWF	AARGB0			; (0.000008*T+0.0385)
		MOVF	MATH_temp1, W		; 
		MOVWF	AARGB1			; 
		MOVF	MATH_temp2, W		; 
		MOVWF	AARGB2			; 
		CALL	FPS32			; odecist

		CALL	AAGR_to_BARG		; presun AARG do BARG
		CALL	Get_Senz_data		; data z SHT do AARG ve flo32
		CALL	FPM32			; vynasobit (pravou zavorku)

		MOVF	tempE, W		; obnovit 
		MOVWF	BEXP			; schovany 
		MOVF	temp0, W		; prvni mezivysledek 
		MOVWF	BARGB0			; (0.001T-4,25)
		MOVF	temp1, W		; 
		MOVWF	BARGB1			; 
		MOVF	temp2, W		; 
		MOVWF	BARGB2			; 
		CALL	FPA32			; pricist

		CALL	INT3224			; a prevest na int 
		BTFSS	AARGB0, 7		; mame zapornou vlhkost?
		GOTO	SOh_kladne		; ne, je kladna
		CLRF	AARGB1			; Vlhkost zaporna, 
		MOVLW	01H			; pripravit 1%
		MOVWF	AARGB2			; vlhkost do registru
		GOTO	SOh_OK			; Mozno vynechat

SOh_kladne					;
		MOVLW	64H			; Dekadicky 100 (%)
		SUBWF	AARGB2, W		; odecist 100 od vlhkosti
		BTFSS	STATUS, C		; Je vlhkost <= 100% ?
		GOTO	SOh_OK			; ano, je (odecet je zaporny)
		CLRF	AARGB1			; Vlhkost > 99%, takze
		MOVLW	63H			; pripravit 99%
		MOVWF	AARGB2			; vlhkost do registru

SOh_OK						; 
		CALL	Prepare_Int16ascii	; pripravit byty pro prevod
		movlw	02H	         	; prevod na 2 mistne
		movwf	digit_count     	; desitkove cislo
		movlw	VlhkJ			; jednotky zacinaji zde
		CALL	int16ascii		; prevest na ascii


AD_mereni					; Mereni MPX4115 tlaku
		MOVLW	020H			; merime 32x
		MOVWF	poc_mer			; zde je pocitadlo
		CLRF	SOUCET			; vynulovat
		CLRF	horniSOUCET		; vynulovat

AD_mereni_Start	BSF	ADCON0,GO_DONE		; Mereni spustit
AD_mereni_loop	BTFSC	ADCON0,GO_DONE		; uz je zmereno?
		GOTO	AD_mereni_loop		; jeste ne

		MOVF	ADRESH, W		; vzit horni 2 z 10 bitu vysledku
		ADDWF	horniSOUCET, F		; pricist vysledek mereni
		BSF	STATUS,RP0		; Select page 1 (80H - FFH)
		MOVF	ADRESL, W		; vzit dolnich 8 bitu vysledku
		BCF	STATUS,RP0		; Select page 0 (00H - 7FH)
		BCF	STATUS, C		; vynulovat CY
		ADDWF	SOUCET, F		; pricist vysledek mereni
		BTFSC	STATUS, C		;
		INCF	horniSOUCET, F		; pretekl-li soucet, pricist to sem

AD_mereni_delay					; pockat 
		DECFSZ	DELAY_1, F		; cca 130ms
		GOTO	AD_mereni_delay		; nez 
		DECFSZ	DELAY_2, F		; pujdeme 
		GOTO	AD_mereni_delay		; merit znova
						; 32*130ms = cca 4.2s 
		DECFSZ	poc_mer, F		; odecist pocet mereni
		GOTO 	AD_mereni_Start		; jeste budeme merit

		; Spocitat tlak z namerene hodnoty
		; Vzorec je: P(kpa)=((Uout / Unap) + 0.095) / 0.009
		; Kde Uout=(2 * Uoz3) - (Vref / 1024 * AD)
		; Pricemz Uoz3 = 2.41V, Vref = 1.42V, Unap = 5V
		; AD = cislo, ktere vrati 10bit A/D prevodnik
		; Pro celociselnou hodnotu v desetinach hPa jeste
		; vysledek vynasobit 100x
		; merit budeme 32x, takze namereno hodnotu delit 32
		; Konecny vzorec je:
		;                   _
		; P(des_hPa)=(11766.6 + (-0.0962968 * AD)
		;          _
		;    11766.6d  = 8C 37 DA AB float (z fprep.exe)
		; -0.0962968d  = 7B C5 37 42 float (z fprep.exe)
		
		CALL	Get_Senz_data		; data z MPX do AARG ve flo32
		; -0.0962968d  = 7B C5 37 42 float (z fprep.exe)
		MOVLW	07BH			; Pripravit nasobeni cislem 
		MOVWF	BEXP			;  -0.0962968d
		MOVLW	0C5H			; 
		MOVWF	BARGB0			; 
		MOVLW	037H			; 
		MOVWF	BARGB1			; 
		MOVLW	042H			; 
		MOVWF	BARGB2			; 
		CALL	FPM32			; vynasobit
		;   11766.6d  = 8C 37 DA AB float (z fprep.exe)
		MOVLW	08CH			; Pripravit pricteni k cislu
		MOVWF	BEXP			; 11766.6d
		MOVLW	037H			; 
		MOVWF	BARGB0			; 
		MOVLW	0DAH			; 
		MOVWF	BARGB1			; 
		MOVLW	0ABH			; 
		MOVWF	BARGB2			; 
		CALL	FPA32			; secist
						; Pripocist kalibraci
		MOVLW	EE_CALIB_P		; adresa float kalibrace P v EEPROM
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	BEXP			; a ulozit ji 
		MOVLW	EE_CALIB_P + 1		; 
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	BARGB0			; a ulozit ji
		MOVLW	EE_CALIB_P + 2		; 
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	BARGB1			; a ulozit ji
		MOVLW	EE_CALIB_P + 3		; 
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	BARGB2			; a ulozit ji
		CALL	FPA32			; secist to

		CALL	INT3224			; a prevest na int 
		CALL	Prepare_Int16ascii	; pripravit byty pro prevod

		movlw	05H	         	; prevod na 5 mistne
		movwf	digit_count     	; desitkove cislo
		movlw	TlakDes			; desetiny zacinaji zde
		CALL	int16ascii		; Prevest hodnotu do ASCII tvaru


Send_WX_data					; a odeslat namerene po RS232
		CALL	serialTXcr		;
		MOVLW	EE_WX_ZACATEK		; zde zacina WX retezec v EEPROM
		MOVWF	temp0			; a ulozit ho sem

EE_Send_232_Loop:			; Posle po RS232 data z EEPROM
		MOVF	temp0,W		; od adresy v 'temp0' do 00H bytu
		CALL	EEPROM_Read_Byte	; zjistit hodnotu
		IORLW	000H			; je to binarni nula?
		BTFSC	STATUS,Z		; Skip if not zero
		GOTO	RAM_Send_232		; Je, vse poslano, navrat
		CALL	serial_SEND_byte		; poslat byte po RS232
		INCF	temp0,F			; posun na dalsi byte
		GOTO	EE_Send_232_Loop	; a zpracovat ho

RAM_Send_232		
		MOVLW	TeplFs			; zacatek zformatovanych
		MOVWF	FSR			; namerenych dat ulozit sem

RAM_Send_232_Loop:				; odesilani retezce z RAM
		MOVF	INDF, W			; nacist znak
		CALL	serial_SEND_byte	; a poslat ho
		INCF	FSR, F			; zvysit FSR
		BTFSS	FSR, 6			; poslano vse? (posledni je 3Fh)
		GOTO	RAM_Send_232_Loop	; jeste ne, dalsi

		GOTO	Start			; A cele znova

Get_Senz_data					; Data z SHT da do float32 AARG
		CLRF	AARGB0			; vynulovat
		MOVF	horniSOUCET, W		; vzit horni bity
		MOVWF	AARGB1			; a dat je sem
		MOVF	SOUCET, W		; vzit dolni bity
		MOVWF	AARGB2			; a dat je sem
		CALL	FLO2432			; prevest
		RETURN				; a hotovo

AAGR_to_BARG					; presune AARG do BARG
		MOVF	AEXP, W			; 
		MOVWF	BEXP			; 
		MOVF	AARGB0, W		;
		MOVWF	BARGB0			; 
		MOVF	AARGB1, W		; 
		MOVWF	BARGB1			; 
		MOVF	AARGB2, W		; 
		MOVWF	BARGB2			; 
		RETURN				; a hotovo
		
Get_Saved_temp					; da teplotu do AARG
		MOVF	MATH_temp0, W		; vzit 
		MOVWF	AARGB0			; schovanou
		MOVF	MATH_temp1, W		; teplotu
		MOVWF	AARGB1			;
		MOVF	MATH_temp2, W		; 
		MOVWF	AARGB2			; 
		CALL	FLO2432			; prevest int24 na float32
		RETURN				; a hotovo

Prepare_Int16ascii				; ulozi 2 byty pro prevod
		MOVF	AARGB1, W		; prevod na ASCII
		MOVWF	AARGB0			; je 16 bitovy HIGH BYTE
Prepare_Int8ascii				; ulozi 1 byte pro prevod
		MOVF	AARGB2, W		; prevod na ASCII
		MOVWF	AARGB1			; je 16 bitovy LOW BYTE
		RETURN				; a hotovo

;------Subroutine WaitMS---------------------------------------------
;
; WaitMS is an approximate millisecond delay. It assumes a 4 MHz
; oscillator, meaning instructions are executed at a rate of 1 MHz.
; I got the timing info (number of cycles per instruction) from the
; Microchip PIC16F84 data sheet.

; the call to this subroutine takes 2 cycles to execute.

WaitMS
	; MOVLW	01H		; 01H pro 4MHz osc, 03H pro 10MHz osc
	; MOVWF	temp1		; 
WaitMSosc			;
	movlw	248		;1 cycle
	movwf	MSDelay		;1 cycle
	nop			;1 cycle--these nops are added to 
	nop			;1 cycle  make the total number of
	nop			;1 cycle  instructions executed in
				;         the routine to be 1000.
				;the nop instruction simply does 
				;nothing except take time to execute.

; The loop below takes four cycles for every time through except the
; last, when it takes five (including the time needed to execute the
; return). So, the total number of instructions executed in getting
; to and returning from this subroutine is:
;
;        2 to get here
;    +   2 to set the MSDelay value
;    +   3 for the nops
;   + 247*4 for the first 247 times through the loop
;    +   5 for the last time through the loop and to return
;   --------
;    = 1000

RepeatWaitMS
	nop			;1 cycle
	decfsz	MSDelay,F	;1 cycle if not zero, 2 if zero
	goto	RepeatWaitMS	;2 cycles
	; DECFSZ	temp1, F	; Pro rychlejsi krystaly...
	; GOTO	WaitMSosc	; opakovat vicekrat...
	return			;2 cycles

;------end WaitMS----------------------------------------------------

;------begin SHT11TXRX-----------------------------------------------
;
; Sends a byte command to the SHT11 temp/humidity sensor and retrieves
; a two-byte response. Sends the response back to the PC as an ASCII
; string representation of the number.
;
; Put the byte to send in SHT11Byte before calling this routine. 

SHT11TXRX
	MOVWF	SHT11Byte		; Pripravit sem predany prikaz

	;make SHT11_DAT an output

	bsf	STATUS,RP0	;switch to bank 1
	bcf	TRISIO,SHT11_DAT	;make Port A data line an output
	bcf	STATUS,RP0	;switch back to bank 0

	;send the Transmission Start sequence:

	bsf	GPIO,SHT11_DAT	;set the data line high
	CLRF	SOUCET			; vynulovat
	bsf	GPIO,SHT11_SCK	;take the clock line high
	CLRF	horniSOUCET		; vynulovat
	bcf	GPIO,SHT11_DAT	;take the data line low
	nop
	bcf	GPIO,SHT11_SCK	;take the clock line low
	nop
	bsf	GPIO,SHT11_SCK	;take the clock line high again
	nop
	bsf	GPIO,SHT11_DAT	;set the data line high again
	
	;load up the counter to loop through the eight bits to send:

	movlw	8
	movwf	temp0

SHT11SendBitLoop
	bcf	GPIO,SHT11_SCK	;take the clock line low

	btfss	SHT11Byte,7	;is the next bit to send a one?
	goto	SHT11SendZero	;nope. Go send a zero.
	bsf	GPIO,SHT11_DAT	;if it's a one, send it.
	goto	SHT11SendBit

SHT11SendZero
	bcf	GPIO,SHT11_DAT	;set the data line to zero

SHT11SendBit
	bsf	GPIO,SHT11_SCK	;take the clock line high to send

	rlf	SHT11Byte,F	;move the next bit into MSB

	decfsz	temp0,F		;dec the counter and check for zero.
	goto	SHT11SendBitLoop	;if not zero, more bits to send

	bcf	GPIO,SHT11_SCK	;take the clock line low

	;no more bits to send. Set the data line to be an input and
	;wait for the ack from the SHT11:

	bsf	STATUS,RP0	;switch to bank 1
	bsf	TRISIO,SHT11_DAT	;make Port A data line an input
	bcf	STATUS,RP0	;switch back to bank 0

	; now look for an ack (SHT11 pulls data line low--should
	; happen on the next rise of the SCK line). If it doesn't
	; happen, return an 'e' and quit.

	bsf	GPIO,SHT11_SCK

SHT11WaitAck
	nop
	btfss	GPIO,SHT11_DAT
	goto	SHT11GotAck

	; if we don't get an ack, quit with 1 in W.

	retlw	'1'

	; we got an Ack. Get ready for the data to be returned. take
	; the clock line low, and then wait for the data line to be
	; pulled low again.

SHT11GotAck
	bcf	GPIO,SHT11_SCK

	; now wait for the data. It takes approximately 210 ms for
	; the temperature measurement, or 55 ms for the humidity
	; measurement, so we'll wait up to 255 ms before giving up.

	movlw	255
	movwf	temp0

SHT11WaitData
	btfss	GPIO,SHT11_DAT
	goto	SHT11DataReady
	call	WaitMS
	decfsz	temp0,F
	goto	SHT11WaitData

	;if we don't get the data, quit with 2 in W.

	retlw	'2'

SHT11DataReady

	; get the most sig byte:

	call	SHT11GetByte
	movf	SHT11Byte,W
	movwf	horniSOUCET
	call	SendAck		;acknowledge the byte

	; get the least sig byte:

	call	SHT11GetByte
	movf	SHT11Byte,W
	movwf	SOUCET
	call	SendAck		;acknowledge the byte

	call	SHT11GetByte	; gets the checksum (not needed)
	call	SendAck		;acknowledge the byte

SHT11TXRXDone
	return

;------end SHT11TXRX--------------------------------------------------

;------begin SHT11GetByte---------------------------------------------
;
; Gets a byte of data from the SHT11. Assumes that the data
; is ready to be sent by the SHT11. Also assumes that SHT11_DAT has
; been set to input. Also assumes that SHT11_SCK has been set to low.
; Returns the byte in SHT11Byte.

SHT11GetByte
	; clear SHT11Byte:

	clrf	SHT11Byte

	; set counter to get eight bits

	movlw	8
	movwf	temp0

SHT11GetByteLoop
	bsf	GPIO,SHT11_SCK	;set the clock high to get the next bit
	nop
	btfss	GPIO,SHT11_DAT	;is the next bit a one?
	goto	SHT11GetZeroBit	;no--it's a zero
	bsf	SHT11Byte,0	;if it's a one, set the LSB in SHT11Byte
	goto	SHT11GotBit

SHT11GetZeroBit
	bcf	SHT11Byte,0	;set the LSB to zero in SHT11Byte

SHT11GotBit
	bcf	GPIO,SHT11_SCK	;set the clock line low again.
	decfsz	temp0,F
	goto	SHT11GetNextBit
	goto	SHT11GetByteDone

SHT11GetNextBit
	rlf	SHT11Byte,F	;move the bits over to get the next bit
	goto	SHT11GetByteLoop

SHT11GetByteDone

	return

;------end SHT11GetByte-----------------------------------------------

;------begin SendAck-------------------------------------------------
;
; send the ack. Set the data line as an output:

SendAck
	bsf	STATUS,RP0	;switch to bank 1
	bcf	TRISIO,SHT11_DAT	;make Port A data line an output
	bcf	STATUS,RP0	;switch back to bank 0

	; now send the ack. Take the data line low.

	bcf	GPIO,SHT11_DAT
	bsf	GPIO,SHT11_SCK
	nop
	bcf	GPIO,SHT11_SCK

	; now make the data line an input again.

	bsf	STATUS,RP0	;switch to bank 1
	bsf	TRISIO,SHT11_DAT	;make Port A data line an input
	bcf	STATUS,RP0	;switch back to bank 0

	return

;------end SendAck---------------------------------------------------

;**********************************************************************************************

;	RCS Header $Id: math16.inc 2.4 1997/02/11 16:58:49 F.J.Testa Exp $

;	$Revision: 2.4 $

;       MATH16 INCLUDE FILE
;
;       IMPORTANT NOTE: The math library routines can be used in a dedicated application on
;       an individual basis and memory allocation may be modified with the stipulation that
;       on the PIC17, P type registers must remain so since P type specific instructions
;	were used to realize some performance improvements.

;*********************************************************************************************
;
;       GENERAL MATH LIBRARY DEFINITIONS
;
;	general literal constants

;	define assembler constants

B0		EQU	0
B1		EQU	1
B2		EQU	2
B3		EQU	3
B4		EQU	4
B5		EQU	5
B6		EQU	6
B7		EQU	7

MSB		EQU	7
LSB		EQU	0


;     define commonly used bits

;     STATUS bit definitions

		#define	_C		STATUS,0
		#define	_Z		STATUS,2

;
;       general register variables (od 0x40H do 0x54H vcetne + 0x55H)
;

ACCB7           EQU     0x40
ACCB6           EQU     0x41
ACCB5           EQU     0x42
ACCB4           EQU     0x43
ACCB3           EQU     0x44
ACCB2           EQU     0x45
ACCB1           EQU     0x46
ACCB0           EQU     0x47
ACC             EQU     0x47    ; most significant byte of contiguous 8 byte accumulator
;
SIGN            EQU     0x49    ; save location for sign in MSB
;
TEMPB3          EQU     0x50
TEMPB2          EQU     0x51
TEMPB1          EQU     0x52
TEMPB0          EQU     0x53
TEMP            EQU     0x53    ; temporary storage
;
;       binary operation arguments
;
AARGB7          EQU     0x40
AARGB6          EQU     0x41
AARGB5          EQU     0x42
AARGB4          EQU     0x43
AARGB3          EQU     0x44
AARGB2          EQU     0x45
AARGB1          EQU     0x46
AARGB0          EQU     0x47
AARG            EQU     0x47    ; most significant byte of argument A
;
BARGB3          EQU     0x4B
BARGB2          EQU     0x4C
BARGB1          EQU     0x4D
BARGB0          EQU     0x4E
BARG            EQU     0x4E    ; most significant byte of argument B
;
;       Note that AARG and ACC reference the same storage locations
;
;*********************************************************************************************
;
;       FIXED POINT SPECIFIC DEFINITIONS
;
;       remainder storage
;
REMB3           EQU     0x40
REMB2           EQU     0x41
REMB1           EQU     0x42
REMB0           EQU     0x43    ; most significant byte of remainder

LOOPCOUNT       EQU     0x54    ; loop counter
;
;*********************************************************************************************
;
;       FLOATING POINT SPECIFIC DEFINITIONS
;
;       literal constants
;
EXPBIAS         EQU     D'127'
;
;       biased exponents
;
EXP             EQU     0x48    ; 8 bit biased exponent

AEXP            EQU     0x48    ; 8 bit biased exponent for argument A

BEXP            EQU     0x4F    ; 8 bit biased exponent for argument B
;
;       floating point library exception flags
;
FPFLAGS         EQU     0x4A    ; floating point library exception flags
                
IOV             EQU     0       ; bit0 = integer overflow flag

FOV             EQU     1       ; bit1 = floating point overflow flag

FUN             EQU     2       ; bit2 = floating point underflow flag

FDZ             EQU     3       ; bit3 = floating point divide by zero flag

NAN		EQU	4	; bit4 = not-a-number exception flag

DOM		EQU	5	; bit5 = domain error exception flag

RND             EQU     6       ; bit6 = floating point rounding flag, 0 = truncation
                                ; 1 = unbiased rounding to nearest LSB

SAT             EQU     7       ; bit7 = floating point saturate flag, 0 = terminate on
                                ; exception without saturation, 1 = terminate on
                                ; exception with saturation to appropriate value

;**********************************************************************************************
;**********************************************************************************************

;	RCS Header $Id: fp32.a16 2.8 1996/10/07 13:50:59 F.J.Testa Exp $

;	$Revision: 2.8 $

;       PIC16 32 BIT FLOATING POINT LIBRARY
;
;       Unary operations: both input and output are in AEXP,AARG
;
;       Binary operations: input in AEXP,AARG and BEXP,BARG with output in AEXP,AARG
;
;       All routines return WREG = 0x00 for successful completion, and WREG = 0xFF
;       for an error condition specified in FPFLAGS.
;
;       All timings are worst case cycle counts
;
;         Routine               Function
;
;       FLO2432         24 bit integer to 32 bit floating point conversion
;       FLO32
;
;               Timing:            RND
;                               0       1
;
;                       0       104     104
;                  SAT
;                       1       110     110
;
;       NRM3232   32 bit normalization of unnormalized 32 bit floating point numbers
;       NRM32
;
;               Timing:            RND
;                               0       1
;
;                       0       90      90
;                  SAT
;                       1       96      96
;
;
;       INT3224         32 bit floating point to 24 bit integer conversion
;       INT32
;
;
;               Timing:            RND
;                               0       1
;
;                       0       104      112
;                  SAT
;                       1       104      114
;
;
;       NRM4032 32 bit normalization of unnormalized 40 bit floating point numbers
;
;               Timing:            RND
;                               0       1
;
;                       0       112     128
;                  SAT
;                       1       112     135
;
;
;       FPA32           32 bit floating point add
;
;               Timing:            RND
;                               0       1
;
;                       0       251     265
;                  SAT
;                       1       251     271
;
;       FPS32           32 bit floating point subtract
;
;               Timing:            RND
;                               0       1
;
;                       0       253     267
;                  SAT
;                       1       253     273
;
;       FPM32           32 bit floating point multiply
;
;               Timing:            RND
;                               0       1
;
;                       0       574     588
;                  SAT
;                       1       574     591
;
;**********************************************************************************************
;**********************************************************************************************
;
;       32 bit floating point representation
;
;       EXPONENT        8 bit biased exponent
;
;                       It is important to note that the use of biased exponents produces
;                       a unique representation of a floating point 0, given by
;                       EXP = HIGHBYTE = MIDBYTE = LOWBYTE = 0x00, with 0 being
;                       the only number with EXP = 0.
;
;       HIGHBYTE        8 bit most significant byte of fraction in sign-magnitude representation,
;                       with SIGN = MSB, implicit MSB = 1 and radix point to the right of MSB
;
;       MIDBYTE         8 bit middle significant byte of sign-magnitude fraction
;
;       LOWBYTE         8 bit least significant byte of sign-magnitude fraction
;
;       EXPONENT        HIGHBYTE        MIDBYTE         LOWBYTE
;
;       xxxxxxxx        S.xxxxxxx       xxxxxxxx        xxxxxxxx
;
;                        |
;                      RADIX
;                      POINT
;
;
;**********************************************************************************************
;**********************************************************************************************

;       Integer to float conversion

;       Input:  24 bit 2's complement integer right justified in AARGB0, AARGB1, AARGB2

;       Use:    CALL    FLO2432 or      CALL    FLO32

;       Output: 32 bit floating point number in AEXP, AARGB0, AARGB1, AARGB2

;       Result: AARG  <--  FLOAT( AARG )

;       Max Timing:     14+90 = 104 clks                SAT = 0
;                       14+96 = 110 clks                SAT = 1

;       Min Timing:     6+28 = 34 clks                  AARG = 0
;                       6+18 = 24 clks

;       PM: 14+38 = 52                                  DM: 7

;----------------------------------------------------------------------------------------------

FLO2432
FLO32           MOVLW           D'23'+EXPBIAS		; initialize exponent and add bias
                MOVWF           EXP
                CLRF            SIGN
                BTFSS           AARGB0,MSB		; test sign
                GOTO            NRM3232
		CALL		Complement3		; na COMF je podprogram
                ;COMF            AARGB2,F                ; if < 0, negate and set MSB in SIGN
                ;COMF            AARGB1,F
                ;COMF            AARGB0,F
		CALL		Complement3a		; na toto je podprogram
                ;INCF            AARGB2,F
                ;BTFSC           _Z
                ;INCF            AARGB1,F
                ;BTFSC           _Z
                ;INCF            AARGB0,F
                BSF             SIGN,MSB

;**********************************************************************************************

;       Normalization routine

;       Input:  32 bit unnormalized floating point number in AEXP, AARGB0, AARGB1,
;               AARGB2, with sign in SIGN,MSB

;       Use:    CALL    NRM3232 or      CALL    NRM32

;       Output: 32 bit normalized floating point number in AEXP, AARGB0, AARGB1, AARGB2

;       Result: AARG  <--  NORMALIZE( AARG )

;       Max Timing:     21+6+7*8+7 = 90 clks            SAT = 0
;                       21+6+7*8+1+12 = 96 clks SAT = 1

;       Min Timing:     22+6 = 28 clks                  AARG = 0
;                       5+9+4 = 18 clks

;       PM: 38                                          DM: 7

;----------------------------------------------------------------------------------------------

NRM3232

NRM32           CLRF            TEMP			; clear exponent decrement
                MOVF            AARGB0,W		; test if highbyte=0
                BTFSS           _Z
                GOTO            NORM3232
                MOVF            AARGB1,W		; if so, shift 8 bits by move
                MOVWF           AARGB0
                MOVF            AARGB2,W
                MOVWF           AARGB1
                CLRF            AARGB2
                BSF             TEMP,3                  ; increase decrement by 8

                MOVF            AARGB0,W		; test if highbyte=0
                BTFSS           _Z
                GOTO            NORM3232
                MOVF            AARGB1,W		; if so, shift 8 bits by move
                MOVWF           AARGB0
                CLRF            AARGB1
                BCF             TEMP,3                  ; increase decrement by 8
                BSF             TEMP,4
        
                MOVF            AARGB0,W		; if highbyte=0, result=0
                BTFSC           _Z
                GOTO            RES032

NORM3232        MOVF            TEMP,W
                SUBWF           EXP,F
                BTFSS           _Z
                BTFSS           _C
                GOTO            SETFUN32

                BCF             _C                      ; clear carry bit

NORM3232A       BTFSC           AARGB0,MSB		; if MSB=1, normalization done
                GOTO            FIXSIGN32
                RLF             AARGB2,F                ; otherwise, shift left and 
                RLF             AARGB1,F                ; decrement EXP
                RLF             AARGB0,F
                DECFSZ          EXP,F
                GOTO            NORM3232A

                GOTO            SETFUN32                ; underflow if EXP=0

FIXSIGN32       BTFSS           SIGN,MSB
                BCF             AARGB0,MSB              ; clear explicit MSB if positive
                RETLW           0

RES032          CLRF            AARGB0                  ; result equals zero
                CLRF            AARGB1
                CLRF            AARGB2
		CLRF		AARGB3
                CLRF            EXP
                RETLW           0

;**********************************************************************************************

;       Normalization routine

;       Input:  40 bit unnormalized floating point number in AEXP, AARGB0, AARGB1,
;               AARGB2, AARGB3 with sign in SIGN,MSB

;       Use:    CALL    NRM4032

;       Output: 32 bit normalized floating point number in AEXP, AARGB0, AARGB1, AARGB2,
;               AARGB3

;       Result: AARG  <--  NORMALIZE( AARG )

;       Max Timing:     38+6*9+12+8 = 112 clks  RND = 0
;                       38+6*9+12+24 = 128 clks RND = 1, SAT = 0
;                       38+6*9+12+31 = 135 clks RND = 1, SAT = 1

;       Min Timing:     33+6 = 39 clks                  AARG = 0
;                       5+9+8 = 22 clks

;       PM: 66                                          DM: 8

;----------------------------------------------------------------------------------------------

NRM4032         CLRF            TEMP			; clear exponent decrement
                MOVF            AARGB0,W		; test if highbyte=0
                BTFSS           _Z
                GOTO            NORM4032
                MOVF            AARGB1,W		; if so, shift 8 bits by move
                MOVWF           AARGB0
                MOVF            AARGB2,W
                MOVWF           AARGB1
                MOVF            AARGB3,W
                MOVWF           AARGB2
                CLRF            AARGB3
                BSF             TEMP,3                  ; increase decrement by 8

                MOVF            AARGB0,W		; test if highbyte=0
                BTFSS           _Z
                GOTO            NORM4032
                MOVF            AARGB1,W		; if so, shift 8 bits by move
                MOVWF           AARGB0
                MOVF            AARGB2,W
                MOVWF           AARGB1
                CLRF            AARGB2
                BCF             TEMP,3                  ; increase decrement by 8
                BSF             TEMP,4
        
                MOVF            AARGB0,W		; test if highbyte=0
                BTFSS           _Z
                GOTO            NORM4032
                MOVF            AARGB1,W		; if so, shift 8 bits by move
                MOVWF           AARGB0
                CLRF            AARGB1
                BSF             TEMP,3                  ; increase decrement by 8
        
                MOVF            AARGB0,W		; if highbyte=0, result=0
                BTFSC           _Z
                GOTO            RES032

NORM4032        MOVF            TEMP,W
                SUBWF           EXP,F
                BTFSS           _Z
                BTFSS           _C
                GOTO            SETFUN32

                BCF             _C                      ; clear carry bit

NORM4032A       BTFSC           AARGB0,MSB		; if MSB=1, normalization done
                GOTO            NRMRND4032
                RLF             AARGB3,F                ; otherwise, shift left and 
                RLF             AARGB2,F                ; decrement EXP
                RLF             AARGB1,F
                RLF             AARGB0,F
                DECFSZ          EXP,F
                GOTO            NORM4032A

                GOTO            SETFUN32                ; underflow if EXP=0

NRMRND4032      BTFSC           FPFLAGS,RND
                BTFSS           AARGB2,LSB
                GOTO            FIXSIGN32
		BTFSS		AARGB3,MSB		; round if next bit is set
                GOTO            FIXSIGN32
		INCF		AARGB2,F
                BTFSC           _Z
                INCF            AARGB1,F
                BTFSC           _Z
                INCF            AARGB0,F

                BTFSS           _Z                      ; has rounding caused carryout?
                GOTO            FIXSIGN32
		CALL		ShiftRight3            ; na RRF AARGB0-2 podprg.
                ;RRF             AARGB0,F                ; if so, right shift
                ;RRF             AARGB1,F
                ;RRF             AARGB2,F
                INCF            EXP,F
                BTFSC           _Z                      ; check for overflow
                GOTO            SETFOV32
                GOTO            FIXSIGN32

;**********************************************************************************************
;**********************************************************************************************

;       Float to integer conversion

;       Input:  32 bit floating point number in AEXP, AARGB0, AARGB1, AARGB2

;       Use:    CALL    INT3224         or      CALL    INT32

;       Output: 24 bit 2's complement integer right justified in AARGB0, AARGB1, AARGB2

;       Result: AARG  <--  INT( AARG )

;       Max Timing:     40+6*7+6+16 = 104 clks		RND = 0
;                       40+6*7+6+24 = 112 clks		RND = 1, SAT = 0
;                       40+6*7+6+26 = 114 clks  	RND = 1, SAT = 1

;       Min Timing:     4 clks

;       PM: 82                                          DM: 6

;----------------------------------------------------------------------------------------------

INT3224
INT32
		MOVF		EXP,W			; test for zero argument
		BTFSC		_Z
		RETLW		0x00

		MOVF            AARGB0,W		; save sign in SIGN
                MOVWF           SIGN
                BSF             AARGB0,MSB		; make MSB explicit

                MOVLW           EXPBIAS+D'23'		; remove bias from EXP
                SUBWF           EXP,F
                BTFSS           EXP,MSB
                GOTO            SETIOV3224
		COMF		EXP,F
		INCF		EXP,F

                MOVLW           8                       ; do byte shift if EXP >= 8
                SUBWF           EXP,W
                BTFSS           _C
                GOTO            TSHIFT3224
                MOVWF           EXP
                RLF             AARGB2,F                ; rotate next bit for rounding
                MOVF            AARGB1,W
                MOVWF           AARGB2
                MOVF            AARGB0,W
                MOVWF           AARGB1
                CLRF            AARGB0

                MOVLW           8                       ; do another byte shift if EXP >= 8
                SUBWF           EXP,W
                BTFSS           _C
                GOTO            TSHIFT3224
                MOVWF           EXP
                RLF             AARGB2,F		; rotate next bit for rounding
                MOVF            AARGB1,W
                MOVWF           AARGB2
                CLRF            AARGB1

                MOVLW           8                       ; do another byte shift if EXP >= 8
                SUBWF           EXP,W
                BTFSS           _C
                GOTO            TSHIFT3224
                MOVWF           EXP
                RLF             AARGB2,F                ; rotate next bit for rounding
                CLRF            AARGB2
		MOVF		EXP,W
		BTFSS		_Z
		BCF		_C
		GOTO		SHIFT3224OK

TSHIFT3224      MOVF            EXP,W                   ; shift completed if EXP = 0
                BTFSC           _Z
                GOTO            SHIFT3224OK

SHIFT3224       BCF             _C
		CALL		ShiftRight3            ; na RRF AARGB0-2 podprg.
                ;RRF             AARGB0,F                ; right shift by EXP
                ;RRF             AARGB1,F
                ;RRF             AARGB2,F
                DECFSZ          EXP,F
                GOTO            SHIFT3224

SHIFT3224OK     BTFSC           FPFLAGS,RND
                BTFSS           AARGB2,LSB
                GOTO            INT3224OK
                BTFSS           _C
                GOTO            INT3224OK
                INCF            AARGB2,F
                BTFSC           _Z
                INCF            AARGB1,F
                BTFSC           _Z
                INCF            AARGB0,F
                BTFSC           AARGB0,MSB		; test for overflow
                GOTO            SETIOV3224

INT3224OK       BTFSS           SIGN,MSB                ; if sign bit set, negate               
                RETLW           0
		CALL		Complement3		; na COMF je podprogram
                ;COMF            AARGB0,F
                ;COMF            AARGB1,F
                ;COMF            AARGB2,F
		CALL		Complement3a		; na toto je podprogram
                ;INCF            AARGB2,F
                ;BTFSC           _Z
                ;INCF            AARGB1,F
                ;BTFSC           _Z
                ;INCF            AARGB0,F
                RETLW           0

IRES03224	CLRF            AARGB0			; integer result equals zero
                CLRF            AARGB1
                CLRF            AARGB2
                RETLW           0

SETIOV3224	BSF             FPFLAGS,IOV             ; set integer overflow flag
                BTFSS           FPFLAGS,SAT             ; test for saturation
                RETLW           0xFF                    ; return error code in WREG

                CLRF            AARGB0			; saturate to largest two's
                BTFSS           SIGN,MSB                ; complement 24 bit integer
                MOVLW           0xFF
                MOVWF           AARGB0			; SIGN = 0, 0x 7F FF FF
                MOVWF           AARGB1			; SIGN = 1, 0x 80 00 00
                MOVWF           AARGB2
                RLF             SIGN,F
                RRF             AARGB0,F
                RETLW           0xFF                    ; return error code in WREG

;**********************************************************************************************
;**********************************************************************************************

;       Floating Point Multiply

;       Input:  32 bit floating point number in AEXP, AARGB0, AARGB1, AARGB2
;               32 bit floating point number in BEXP, BARGB0, BARGB1, BARGB2

;       Use:    CALL    FPM32

;       Output: 32 bit floating point product in AEXP, AARGB0, AARGB1, AARGB2

;       Result: AARG  <--  AARG * BARG

;       Max Timing:     26+23*22+21+21 = 574 clks       RND = 0
;                       26+23*22+21+35 = 588 clks       RND = 1, SAT = 0
;                       26+23*22+21+38 = 591 clks       RND = 1, SAT = 1

;       Min Timing:     6+6 = 12 clks                   AARG * BARG = 0
;                       24+23*11+21+17 = 315 clks

;       PM: 94                                          DM: 14

;----------------------------------------------------------------------------------------------

FPM32           MOVF            AEXP,W                  ; test for zero arguments
                BTFSS           _Z
                MOVF            BEXP,W
                BTFSC           _Z
                GOTO            RES032

M32BNE0         MOVF            AARGB0,W
                XORWF           BARGB0,W
                MOVWF           SIGN                    ; save sign in SIGN

                MOVF            BEXP,W
                ADDWF           EXP,F
                MOVLW           EXPBIAS-1
                BTFSS           _C
                GOTO            MTUN32

                SUBWF           EXP,F
                BTFSC           _C
                GOTO            SETFOV32                ; set multiply overflow flag
                GOTO            MOK32

MTUN32          SUBWF           EXP,F
                BTFSS           _C
                GOTO            SETFUN32

MOK32		MOVF		AARGB0,W
		MOVWF		AARGB3
		MOVF		AARGB1,W
		MOVWF		AARGB4
		MOVF		AARGB2,W
		MOVWF		AARGB5
		BSF             AARGB3,MSB              ; make argument MSB's explicit
                BSF             BARGB0,MSB
                BCF             _C
                CLRF            AARGB0			; clear initial partial product
                CLRF            AARGB1
                CLRF            AARGB2
                MOVLW           D'24'
                MOVWF           TEMP                    ; initialize counter

MLOOP32         BTFSS           AARGB5,LSB              ; test next bit
                GOTO            MNOADD32

MADD32          MOVF            BARGB2,W
                ADDWF           AARGB2,F
                MOVF            BARGB1,W
                BTFSC           _C
                INCFSZ          BARGB1,W
                ADDWF           AARGB1,F

                MOVF            BARGB0,W
                BTFSC           _C
                INCFSZ          BARGB0,W
                ADDWF           AARGB0,F

MNOADD32        CALL		ShiftRight3            ; na RRF AARGB0-2 podprg.
		;RRF             AARGB0,F
                ;RRF             AARGB1,F
                ;RRF             AARGB2,F
                RRF             AARGB3,F
                RRF             AARGB4,F
                RRF             AARGB5,F
                BCF             _C
                DECFSZ          TEMP,F
                GOTO            MLOOP32

                BTFSC           AARGB0,MSB               ; check for postnormalization
                GOTO            MROUND32
                RLF             AARGB3,F
                RLF             AARGB2,F
                RLF             AARGB1,F
                RLF             AARGB0,F
                DECF            EXP,F

MROUND32        BTFSC           FPFLAGS,RND
                BTFSS           AARGB2,LSB
                GOTO            MUL32OK
		BTFSS		AARGB3,MSB
                GOTO            MUL32OK
		INCF		AARGB2,F
                BTFSC           _Z
                INCF            AARGB1,F
                BTFSC           _Z
                INCF            AARGB0,F

                BTFSS           _Z                      ; has rounding caused carryout?
                GOTO            MUL32OK
		CALL		ShiftRight3            ; na RRF AARGB0-2 podprg.
                ;RRF             AARGB0,F                ; if so, right shift
                ;RRF             AARGB1,F
                ;RRF             AARGB2,F
                INCF            EXP,F
                BTFSC           _Z                      ; check for overflow
                GOTO            SETFOV32

MUL32OK         BTFSS           SIGN,MSB
                BCF             AARGB0,MSB		; clear explicit MSB if positive

                RETLW           0  

SETFOV32        BSF             FPFLAGS,FOV             ; set floating point underflag
                BTFSS           FPFLAGS,SAT             ; test for saturation
                RETLW           0xFF                    ; return error code in WREG

                MOVLW           0xFF
                MOVWF           AEXP                    ; saturate to largest floating
                MOVWF           AARGB0                  ; point number = 0x FF 7F FF FF
                MOVWF           AARGB1                  ; modulo the appropriate sign bit
                MOVWF           AARGB2
                RLF             SIGN,F
                RRF             AARGB0,F
                RETLW           0xFF                    ; return error code in WREG

;**********************************************************************************************

SETFUN32        BSF             FPFLAGS,FUN             ; set floating point underflag
                BTFSS           FPFLAGS,SAT             ; test for saturation
                RETLW           0xFF                    ; return error code in WREG

                MOVLW           0x01                    ; saturate to smallest floating
                MOVWF           AEXP                    ; point number = 0x 01 00 00 00
                CLRF            AARGB0                  ; modulo the appropriate sign bit
                CLRF            AARGB1
                CLRF            AARGB2
                RLF             SIGN,F
                RRF             AARGB0,F
                RETLW           0xFF                    ; return error code in WREG

;**********************************************************************************************
;**********************************************************************************************

;       Floating Point Subtract

;       Input:  32 bit floating point number in AEXP, AARGB0, AARGB1, AARGB2
;               32 bit floating point number in BEXP, BARGB0, BARGB1, BARGB2

;       Use:    CALL FPS32

;       Output: 32 bit floating point sum in AEXP, AARGB0, AARGB1, AARGB2

;       Result: AARG  <--  AARG - BARG

;       Max Timing:     2+251 = 253 clks                RND = 0
;                       2+265 = 267 clks                RND = 1, SAT = 0
;                       2+271 = 273 clks                RND = 1, SAT = 1

;       Min Timing:     2+12 = 14 clks

;       PM: 2+146 = 148                         DM: 14

;----------------------------------------------------------------------------------------------

FPS32           MOVLW           0x80
                XORWF           BARGB0,F

;**********************************************************************************************

;       Floating Point Add

;       Input:  32 bit floating point number in AEXP, AARGB0, AARGB1, AARGB2
;               32 bit floating point number in BEXP, BARGB0, BARGB1, BARGB2

;       Use:    CALL FPA32

;       Output: 32 bit floating point sum in AEXP, AARGB0, AARGB1, AARGB2

;       Result: AARG  <--  AARG - BARG

;       Max Timing:     31+41+6*7+6+41+90 = 251 clks            RND = 0
;                       31+41+6*7+6+55+90 = 265 clks            RND = 1, SAT = 0
;                       31+41+6*7+6+55+96 = 271 clks            RND = 1, SAT = 1

;       Min Timing:     8+4 = 12 clks

;       PM: 146                                                 DM: 14

;----------------------------------------------------------------------------------------------

FPA32           MOVF            AARGB0,W                ; exclusive or of signs in TEMP
                XORWF           BARGB0,W
                MOVWF           TEMP

		CLRF		AARGB3			; clear extended byte
		CLRF		BARGB3

                MOVF            AEXP,W                  ; use AARG if AEXP >= BEXP
                SUBWF           BEXP,W
                BTFSS           _C
                GOTO            USEA32

                MOVF            BEXP,W                  ; use BARG if AEXP < BEXP
                MOVWF           AARGB5			; therefore, swap AARG and BARG
                MOVF            AEXP,W
                MOVWF           BEXP
                MOVF            AARGB5,W
                MOVWF           AEXP

                MOVF            BARGB0,W
                MOVWF           AARGB5
                MOVF            AARGB0,W
                MOVWF           BARGB0
                MOVF            AARGB5,W
                MOVWF           AARGB0

                MOVF            BARGB1,W
                MOVWF           AARGB5
                MOVF            AARGB1,W
                MOVWF           BARGB1
                MOVF            AARGB5,W
                MOVWF           AARGB1

                MOVF            BARGB2,W
                MOVWF           AARGB5
                MOVF            AARGB2,W
                MOVWF           BARGB2
                MOVF            AARGB5,W
                MOVWF           AARGB2

USEA32          MOVF            BEXP,W                  ; return AARG if BARG = 0
                BTFSC           _Z
                RETLW           0x00

                MOVF            AARGB0,W
                MOVWF           SIGN                    ; save sign in SIGN
                BSF             AARGB0,MSB              ; make MSB's explicit
                BSF             BARGB0,MSB

                MOVF            BEXP,W                  ; compute shift count in BEXP
                SUBWF           AEXP,W
                MOVWF           BEXP
                BTFSC           _Z
                GOTO            ALIGNED32

                MOVLW           8
                SUBWF           BEXP,W
                BTFSS           _C                      ; if BEXP >= 8, do byte shift
                GOTO            ALIGNB32
                MOVWF           BEXP
                MOVF            BARGB2,W		; keep for postnormalization
		MOVWF		BARGB3
                MOVF            BARGB1,W
		MOVWF		BARGB2
                MOVF            BARGB0,W
		MOVWF		BARGB1
                CLRF            BARGB0

                MOVLW           8
                SUBWF           BEXP,W
                BTFSS           _C                      ; if BEXP >= 8, do byte shift
                GOTO            ALIGNB32
                MOVWF           BEXP
                MOVF            BARGB2,W		; keep for postnormalization
		MOVWF		BARGB3
                MOVF            BARGB1,W
		MOVWF		BARGB2
                CLRF            BARGB1

                MOVLW           8
                SUBWF           BEXP,W
                BTFSS           _C                      ; if BEXP >= 8, BARG = 0 relative to AARG
                GOTO            ALIGNB32
                MOVF            SIGN,W
                MOVWF           AARGB0
                RETLW           0x00

ALIGNB32        MOVF            BEXP,W                  ; already aligned if BEXP = 0
                BTFSC           _Z
                GOTO            ALIGNED32

ALOOPB32        BCF             _C                      ; right shift by BEXP
                RRF             BARGB0,F
                RRF             BARGB1,F
		RRF		BARGB2,F
		RRF		BARGB3,F
                DECFSZ          BEXP,F
                GOTO            ALOOPB32

ALIGNED32       BTFSS           TEMP,MSB                ; negate if signs opposite
                GOTO            AOK32

		COMF		BARGB3,F
		COMF		BARGB2,F
                COMF            BARGB1,F
                COMF            BARGB0,F
                INCF            BARGB3,F
                BTFSC           _Z
                INCF            BARGB2,F
		BTFSC		_Z
		INCF		BARGB1,F
		BTFSC		_Z
		INCF		BARGB0,F

AOK32
                MOVF   		BARGB3,W
                ADDWF   	AARGB3,F
                MOVF            BARGB2,W
                BTFSC           _C
                INCFSZ          BARGB2,W
                ADDWF           AARGB2,F
                MOVF            BARGB1,W
                BTFSC           _C
                INCFSZ          BARGB1,W
                ADDWF           AARGB1,F
                MOVF            BARGB0,W
                BTFSC           _C
                INCFSZ          BARGB0,W
                ADDWF           AARGB0,F

                BTFSC           TEMP,MSB
                GOTO            ACOMP32
                BTFSS           _C
                GOTO            NRMRND4032

		CALL		ShiftRight3            ; na RRF AARGB0-2 podprg.
                ;RRF             AARGB0,F               ; shift right and increment EXP
                ;RRF             AARGB1,F
                ;RRF             AARGB2,F
		RRF		AARGB3,F
                INCFSZ          AEXP,F
                GOTO            NRMRND4032
                GOTO            SETFOV32

ACOMP32         BTFSC           _C
                GOTO            NRM4032			; normalize and fix sign

		CALL		Complement4		; na COMF je podprogram
		;COMF		AARGB3,F
                ;COMF            AARGB2,F		; negate, toggle sign bit and
                ;COMF            AARGB1,F		; then normalize
                ;COMF            AARGB0,F
		CALL		Complement4a		; na toto je podprogram
                ;INCF            AARGB3,F
                ;BTFSC           _Z
                ;INCF            AARGB2,F
                ;BTFSC           _Z
                ;INCF            AARGB1,F
                ;BTFSC           _Z
                ;INCF            AARGB0,F

                MOVLW           0x80
                XORWF           SIGN,F
                GOTO            NRM32


		; AN670 32BIT NUMBER TO ASCII (ale zatim jen do cisla 9999!)

;****************************************************************************
;*		Floating Point to ASCII
;*
;* INPUT: 32 bit floating point number in AEXP, AARGB0, AARGB1, AARGB2
;*        For this example, the number must be between 0.000 and 9.999.
;*        (You can easily change the number range to suit your needs.)
;*
;* OUTPUT: ones, tenths, hundredths, thousandths (ASCII digit in each)
;*         
;*
;* USED: INDF,FSR,AARG,BARG,REMB,digit_count
;*
;* PROCEDURE: The floating point number in AARG is multiplied by 1000.
;*            Then the product is divided by 10 three times.  After each
;*            divide, the remainder is kept.  
;*
;*            After each digit is obtained, 30H is added to it to make it
;*            an ASCII representation of that number.  Then, the ASCII
;*            value is stored in register RAM at the locations specified
;*            in the "cblock."      
;*
;*	Note: The ASCII decimal point is not generated by this routine.
;*            You must output the decimal point in the correct decimal
;*            position for your application.  For this example, the
;*            decimal point is after the first digit: ones.
;*            
;* The following files are needed for this routine to function.
;*  p16c74a.inc		-- or any other midrange processor include file 
;*                         include the processor file in your "main" file
;*
;*  math16.inc          -- constant and variable definitions for 
;*                         AN575 floating point routines and
;*                         AN617 fixed point routines, both are used
;*                         in this float to ASCII routine
;*                         "include" this file in your "main" program
;*
;*  fxd26.a16 		-- fixed point 32/16 divide, included at the end
;*                         of this routine.
;*
;*  fp32.a16		-- 32 bit float to 32 bit integer conversion 
;*                         included at the end of this program. 
;* 
;****************************************************************************


;RAM Register Definitions       

digit_count	EQU	055H	;counter used to cycle through each digit 


;SIG_FIG EQU     5              ;set SIG_FIG equal to the number of 
                                ;significant figures in your decimal number
                                ;for example: ones, tenths,hundredths, 
                                ;thousandths, requires 4 sig figs


int16ascii			; Prevod 16bitove binarni hodnoty na ascii
	
	; nasledujici tri radky udelat pred volanim rutiny, tak aby rutina dostala 
	; adresu kam ukladat vysledek ve 'W' a pocet mist byl v digit_count
	;movlw	SIG_FIG         ;load counter with the number of
	;movwf	digit_count     ;significant figures the decimal number	
	;movlw	last_digit	;

	movwf	FSR		;pointer = address of smallest digit

flo_asclp
	clrf	BARGB0		;Make the divisor 10.  
	movlw	d'10'
	movwf	BARGB1

	call	FXD1616U	;divide (16 bit fixed) / 10 (to get remainder)
	
	movf	REMB1,w		;put remainder in w register
	movwf	INDF		;put number into appropriate digit position

	movlw	0x30
	addwf	INDF,f		;add 30H to decimal number to convert to ASCII

	decf	FSR,f		;move pointer to next digit 	

	decfsz	digit_count,f
	goto	flo_asclp

	return


;**********************************************************************************************
;**********************************************************************************************

;	RCS Header $Id: fxd66.a16 2.4 1997/02/27 01:20:22 F.J.Testa Exp $

;	$Revision: 2.4 $

;       16/16 PIC16 FIXED POINT DIVIDE ROUTINES
;
;       Input:  fixed point arguments in AARG and BARG
;
;       Output: quotient AARG/BARG followed by remainder in REM
;
;       All timings are worst case cycle counts
;
;       It is useful to note that the additional unsigned routines requiring a non-power of two
;       argument can be called in a signed divide application where it is known that the
;       respective argument is nonnegative, thereby offering some improvement in
;       performance.
;
;         Routine            Clocks     Function
;
;       FXD1616U    373 16 bit/16 bit -> 16.16 unsigned fixed point divide
;
;       The above timings are based on the looped macros. If space permits,
;       approximately 65-69 clocks can be saved by using the unrolled macros.
;

;**********************************************************************************************
;**********************************************************************************************

;       16/16 Bit Division Macros


UDIV1616L       macro

;       restore = 23 clks,  nonrestore = 17 clks

;       Max Timing:     2+15*23+22 = 369 clks

;       Min Timing:     2+15*17+16 = 273 clks

;       PM: 24                                  DM: 7

                MOVLW           D'16'
                MOVWF           LOOPCOUNT

LOOPU1616       RLF             AARGB0,W
                RLF             REMB1, F
                RLF             REMB0, F
                MOVF            BARGB1,W
                SUBWF           REMB1, F
                MOVF            BARGB0,W
                BTFSS           _C
                INCFSZ          BARGB0,W
                SUBWF           REMB0, F

                BTFSC           _C
                GOTO            UOK66LL         
                MOVF            BARGB1,W
                ADDWF           REMB1, F
                MOVF            BARGB0,W
                BTFSC           _C
                INCFSZ          BARGB0,W
                ADDWF           REMB0, F

                BCF             _C

UOK66LL RLF             AARGB1, F
                RLF             AARGB0, F

                DECFSZ          LOOPCOUNT, F
                GOTO            LOOPU1616

                endm

;**********************************************************************************************
;**********************************************************************************************
        
;       16/16 Bit Unsigned Fixed Point Divide 16/16 -> 16.16

;       Input:  16 bit unsigned fixed point dividend in AARGB0, AARGB1
;               16 bit unsigned fixed point divisor in BARGB0, BARGB1

;       Use:    CALL    FXD1616U

;       Output: 16 bit unsigned fixed point quotient in AARGB0, AARGB1
;               16 bit unsigned fixed point remainder in REMB0, REMB1

;       Result: AARG, REM  <--  AARG / BARG

;       Max Timing:     2+369+2 = 373 clks

;       Min Timing:     2+273+2 = 277 clks

;       PM: 2+24+1 = 27         DM: 7

FXD1616U        CLRF            REMB0
                CLRF            REMB1

                UDIV1616L

                RETLW           0x00

;**********************************************************************************************
		; Pro ziskani mista v PICce vytazeno neco jako podprogramy
Complement4			
		COMF		AARGB3,F
Complement3
                COMF            AARGB2,F		;
                COMF            AARGB1,F		;
                COMF            AARGB0,F
		RETURN					; 

Complement4a
                INCF            AARGB3,F
                BTFSC           _Z
Complement3a
                INCF            AARGB2,F
                BTFSC           _Z
                INCF            AARGB1,F
                BTFSC           _Z
                INCF            AARGB0,F
		RETURN					; 

ShiftRight3
                RRF             AARGB0,F               ; 
                RRF             AARGB1,F
                RRF             AARGB2,F
		RETURN

;**********************************************************************************************

		; SERIAL.ASM


serial_Delay:
		MOVWF	serialDelayCount	; ulozit W do delay pocitadla
		NOP				; Helps with high speed	

serial_Delay_Loop:				; odecitaci smycka
		DECFSZ	serialDelayCount,F	; odecist
		GOTO	serial_Delay_Loop	; jeste jsme neodcetli vse
		RETURN				; odecteno, Return


InitIO		BSF	STATUS,RP0		; Select page 1 (80H - FFH)
		CALL	03FFH			; Vyzvednout OSCCAL value
		MOVWF	OSCCAL			; A ulozit ho sem
		BCF	TRISIO,OUT232_GP5	; Setup OUTPUT
		BCF	TRISIO,SHT11_SCK	; Setup OUTPUT
		MOVLW	b'10100111'		; Prescaler -> TMR0,
		MOVWF	OPTION_REG		; 1:256, rising edge
		MOVLW	051H			; Fosc/16 a GP0 jako ANALOG in
		MOVWF	ANSEL			; nastavit tady
		BCF	STATUS,RP0		; Select page 0 (00H - 7FH)
		BCF	GPIO,OUT232_GP5		; Serial OUT=0
		MOVLW	0C1H			; Right justified result,
		MOVWF	ADCON0			; VREF=GP1, zapnout A/D modul 
		MOVLW	EE_DELAY_TIME		; adresa RS-232 delay bytu v EEPROM
		CALL	EEPROM_Read_Byte	; nacist z EEPROM hodnotu
		MOVWF	delay_time		; a ulozit ji sem
		RETURN				; Return from subroutine

serial_SEND_byte:				; Odeslat znak ve W
serial_Transmit:				; odesle byte po RS232
		MOVWF	serialData		; ulozit byte pro odeslani
		MOVLW	00AH			; 8 bitu 1 stop a 1 start bit
		MOVWF	serialCount		;
		BCF	STATUS,C		; Clear carry flag

serial_Transmit_Loop:
		BCF	GPIO,OUT232_GP5		; zaciname s LOW na vystupu
		BTFSS	STATUS,C		; Skip if carry set
		BSF	GPIO,OUT232_GP5		; kdyz posilame 0, poslat HIGH
		MOVF	delay_time, W		; rychlost RS232
		CALL	serial_Delay		; cekat dobu bitu
		BSF	STATUS,C		; Set carry flag
		RRF	serialData,F		; odrotovat bity odesilaneho 
		DECFSZ	serialCount,F		; bytu, odecist odeslany bit
		GOTO	serial_Transmit_Loop	; jeste neodeslany vsechny
		RETURN				; odeslano, Return


serialTXlfcr:
		MOVLW	00AH			; Odeslat LF
		CALL	serial_SEND_byte
serialTXcr:
		MOVLW	00DH			; Odeslat CR
		GOTO	serial_SEND_byte		
		;RETURN

serial_Receive:					;
		BCF	serialData,00		; pripravime prijaty bit jako 0
		BTFSS	GPIO,IN232_GP3	; pokud neprijimame data
		RETLW	000H			; tak navrat
		MOVLW	009H			; jinak cteme
		MOVWF	serialCount		; 9 bitu
		MOVLW	00AH			; rychlost RS232 (1/3 delay 9k6)
		CALL	serial_Delay		; cekat delku bitu

serial_Receive_Loop:				; 
		BCF	STATUS,C		; Clear carry flag
		BTFSS	GPIO,IN232_GP3	; pokud prichazi 0
		BSF	STATUS,C		; Set carry flag
		RRF	serialData,F		; odrotovat serial data bits
		MOVF	delay_time, W		; rychlost RS232
		CALL	serial_Delay		; cekat delku bitu
		NOP				; keep timing w/ transmit
		DECFSZ	serialCount,F		; mame vsechny bity?
		GOTO	serial_Receive_Loop	; jeste ne, tak dalsi
		MOVF	serialData,W		; prijaty byte do W

serial_Receive_Stop:				;
		BTFSC	GPIO,IN232_GP3	; cekat na 0 na serial in
		GOTO	serial_Receive_Stop	; je tam stale 1 (stop bit)
		BSF	serialData,00		; bit 0 nastavit na 1
		RETURN				; Return from subroutine


serial_Receive_BYTE:				; prijme byte z RS232 portu
		CALL	serial_Receive		; nacist byte
		BTFSS	serialData,00		; nacten? 
		GOTO	serial_Receive_BYTE	; ne, data zadna neprichazeji
		RETURN				; Byte nacten, Return
		
		; EEPROM.ASM

EEPROM_Read_Byte:			; cte byte z adresy W EEPROM
		;ANDLW	03FH		; odmaskovat bity 6 a 7 pro 64Bytu
		ANDLW	07FH		; odmaskovat bity 7 pro 128Bytu
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		MOVWF	EEADR		; zapsat adresu, ze ktere budeme cist
		BSF	EECON1,RD	; bude se cist z EEPROM 
		MOVF	EEDATA,W	; a nacteme byte
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)
		RETURN			; Return from subroutine


EEPROM_Write_Byte:			; zapise byte na adresu W EEPROM
		ANDLW	03FH		; odmaskovat bity 6 a 7 pro 64Bytu
		;ANDLW	07FH		; odmaskovat bit 7 pro 128Bytu
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		MOVWF	EEADR		; zapsat adresu, kam budeme zapisovat
		BCF	INTCON,GIE	; Generalni zakaz preruseni
		BSF	EECON1,WREN	; Povolit EEPROM write
		MOVLW	055H		; REQUIRED WRITE SEQUENCE START
		MOVWF	EECON2		; Write 55h
		MOVLW	0AAH		; 
		MOVWF	EECON2		; Write AAh
		BSF	EECON1,WR	; Set WR bit, zapis spusten
		BCF	EECON1,WREN	; Zakazat EEPROM write
		BSF	INTCON,GIE	; Preruseni opet povolit

EEPROM_Write_Complete_Loop:		; ceka az se zapise do EEPROM
		BTFSC	EECON1,WR	; uz se byte zapsal?
		GOTO	EEPROM_Write_Complete_Loop	; jeste ne, cekat
		BCF	STATUS,RP0	; zapsano, Select page 0 (00H - 7FH)
		RETURN			; Return from subroutine

Kalibrace	
		CALL	serialTXlfcr	; odradkovat
		MOVLW	03EH		; prompt
		CALL	serial_SEND_byte ; zobrazit
					;
Kalibr_Loop:				; Hlavni smycka Programu
		CALL	serial_Receive	; cist z RS232
		BTFSS	serialData,00	; prislo neco?
		MOVWF	temp0		; prislo, ulozit to sem
		XORLW	01BH		; je to ESC ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Serial_Receive_ESC	; prisel ESC, co prijde dal?
		GOTO	Kalibr_Loop	; bylo to neco jineho, ignorovat to

Serial_Receive_ESC:			; prislo ESC, zpracovavame asi prikaz
		CALL	serial_Receive_BYTE	; cist z RS232
		MOVWF	temp0		; ulozit to sem
		;XORLW	01BH		; prislo ESC ?
		;BTFSC	STATUS,Z	; Skip if not zero
		;GOTO	Serial_Receive_ESC	; prislo ESC, cekame na prikaz
		;MOVF	temp0,W		; obnovit prijaty znak
		XORLW	a'D'		; prislo D ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Write_Config_to_EEPROM	; 'D'=zapis konfigurace
		MOVF	temp0,W		; obnovit prijaty znak
		XORLW	a'U'		; prislo U ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Send_Config_from_EEPROM	; 'U'=precteni konfigurace
		MOVF	temp0,W		; obnovit prijaty znak
		XORLW	a'M'		; prislo M ?
		BTFSC	STATUS,Z	; Skip if not zero
		GOTO	Startup_delay	; 'M'=mereni
		GOTO	Kalibr_Loop	; bylo to neco jineho, ignorovat to

Write_Config_to_EEPROM:			; zapise data z RS232 do EEPROM
		CLRF	temp0		; vynulovat ukazovatko

Write_Config_to_EEPROM_Loop:		; smycka zapisu do EEPROM
		CALL	serial_Receive_BYTE	; prijmout byte z RS232
		BSF	STATUS,RP0	; Select page 1 (80H - FFH)
		MOVWF	EEDATA		; ulozit ho sem
		BCF	STATUS,RP0	; Select page 0 (00H - 7FH)
		MOVF	temp0,W		; sem dat adresu bytu v EEPROM
		CALL	EEPROM_Write_Byte	; zapsat byte do EEPROM
		INCF	temp0,F		; posun na dalsi byte
		BTFSS	temp0,06		; bylo jich uz 64?
		GOTO	Write_Config_to_EEPROM_Loop	; jeste ne, dalsi
		GOTO	Kalibrace	; zapsano, jedeme dokolecka

Send_Config_from_EEPROM:		; nacte data z EEPROM a posle na RS232
		MOVLW	EE_LEN		; delka dat v EEPROM
		CALL	serial_SEND_byte	; a poslat ji jako prvni
		CLRF	temp0		; vynulovat ukazovatko

Send_Config_from_EEPROM_Loop:		; smycka cteni z EEPROM
		MOVF	temp0,W		; vzit adresu bytu v EEPROM
		CALL	EEPROM_Read_Byte	; nacist ho
		CALL	serial_SEND_byte	; a poslat po RS232
		INCF	temp0,F		; posun na dalsi byte
		BTFSS	temp0,06		; bylo jich uz 64?
		GOTO	Send_Config_from_EEPROM_Loop	; jeste ne, dalsi
		GOTO	Kalibrace	; vse odeslano, jedeme dokolecka


		; EEPROM procesoru

		ORG	2100H
EE_LEN		EQU	040H		; velikost EEPROM pro konfig po 232
EE_DELAY_TIME	EQU	040H		; Adresa RS-232 DELAY time v EEPROM
EE_WX_ZACATEK	EQU	041H		; Adresa zacatku WX ramce
EE_CALIB_P	EQU	00FH		; Adresa kalibrace tlaku
EE_CALIB_H	EQU	022H		; Adresa kalibrace vlhkosti
EE_CALIB_T	EQU	038H		; Adresa kalibrace tlaku

	DATA	0050H			; 'P'
		DATA	0072H		; 'r'
		DATA	0065H		; 'e'
		DATA	0073H		; 's'
		DATA	0073H		; 's'
		DATA	0075H		; 'u'
		DATA	0072H		; 'r'
		DATA	0065H		; 'e'
		DATA	002DH		; '-'
		DATA	0046H		; 'F'
		DATA	004CH		; 'L'
		DATA	004FH		; 'O'
		DATA	0033H		; '3'
		DATA	0032H		; '2'
		DATA	003AH		; ':' pro 259mnm = 190 (desetin hPa)
					; addr: 0Fh
		DATA	0086H		; '' EXP            86
	DATA	003EH			; '' ARGB0          3E
		DATA	0000H		; '' ARGB1          00
		DATA	0000H		; '' ARGB2          00
		DATA	0048H		; 'H'
		DATA	0075H		; 'u'
		DATA	006DH		; 'm'
		DATA	0069H		; 'i'
		DATA	0064H		; 'd'
		DATA	0069H		; 'i'
		DATA	0074H		; 't'
		DATA	0079H		; 'y'
		DATA	002DH		; '-'
		DATA	0046H		; 'F'
		DATA	004CH		; 'L'
		DATA	004FH		; 'O'
		DATA	0033H		; '3'
	DATA	0032H			; '2'
		DATA	003AH		; ':' default zmeren +15
					; addr: 22h
		DATA	0082H		; '' EXP             82
		DATA	0070H		; '' ARGB0           70
		DATA	0000H		; '' ARGB1           00
		DATA	0000H		; '' ARGB2           00
		DATA	0054H		; 'T'
		DATA	0065H		; 'e'
		DATA	006DH		; 'm'
		DATA	0070H		; 'p'
		DATA	0065H		; 'e'
		DATA	0072H		; 'r'
		DATA	0061H		; 'a'
		DATA	0074H		; 't'
		DATA	0075H		; 'u'
		DATA	0072H		; 'r'
	DATA	0065H			; 'e'
		DATA	002DH		; '-'
		DATA	0046H		; 'F'
		DATA	004CH		; 'L'
		DATA	004FH		; 'O'
		DATA	0033H		; '3'
		DATA	0032H		; '2'
		DATA	003AH		; ':' zjisteno -20 (desetin C)
					; addr: 38h
		DATA	0083H		; '' EXP	83
		DATA	00A0H		; '' ARGB0	A0
		DATA	0000H		; '' ARGB1	00
		DATA	0000H		; '' ARGB2	00
		DATA	0057H		; 'W'
		DATA	0058H		; 'X'
		DATA	0030H		; '0'
		DATA	0031H		; '1'
		; RS-232 delay time should be: ((ClockSpeed/4/SerialSpeed)-14)/3
	DATA	001EH			; 9k6 RS232 @4MHz=1Eh @10MHz=52h
		DATA	001BH		; 'ESC'
		DATA	0077H		; 'w'
		DATA	0030H		; '0'
		DATA	0030H		; '0'
		DATA	0030H		; '0'
		DATA	002FH		; '/'
		DATA	0030H		; '0'
		DATA	0030H		; '0'
		DATA	0030H		; '0'
		DATA	0067H		; 'g'
		DATA	0030H		; '0'
		DATA	0030H		; '0'
		DATA	0030H		; '0'
		DATA	0074H		; 't'
		DATA	0000H		;

		;000/000g000tFFFbBBBBBhHH<CR>

		; Pojistky procesoru
						
		ORG	2007H

		DATA	1184H


		END				;




